Imports System.Data.SqlClient

Public Class cDatabase

	Dim eConn As String

	'Constructor sets the database connection string
	Public Sub New(ByVal sConn As String)
		eConn = sConn
	End Sub

	'In the tutorial this is called ExecuteNonQuery - all it does it execute a query
	Public Sub ExecuteQuery(ByVal sQuery As String)

		Dim conn As SqlConnection
		Dim db As SqlCommand

		conn = New SqlConnection(eConn)
		conn.Open()
		db = New SqlCommand(sQuery, conn)
		db.ExecuteNonQuery()

		conn.Close()
		db.Dispose()

	End Sub

	'builds a proper sql string from 2 arrays and inserts into the database
	Public Sub sqlInsert(ByVal dataNames(), ByVal dataValues(), ByVal tableName)

		Dim sqlNames As String
		Dim sqlValues As String
		Dim x As Integer

		sqlNames = "INSERT INTO " & tableName & "("
		For x = 0 To UBound(dataNames)
			If x <> UBound(dataNames) Then
				sqlNames = sqlNames & Replace(dataNames(x), "'", "''") & ", "
				sqlValues = sqlValues & "'" & Replace(dataValues(x), "'", "''") & "', "
			Else
				sqlNames = sqlNames & Replace(dataNames(x), "'", "''") & ") VALUES("
				sqlValues = sqlValues & "'" & Replace(dataValues(x), "'", "''") & "')"
			End If
		Next

		ExecuteQuery(sqlNames & sqlValues)

	End Sub

	'builds a proper sql string from 2 arrays and updates the database
	Public Sub sqlUpdate(ByVal dataNames(), ByVal dataValues(), ByVal tableName, ByVal condition)

		Dim sql As String
		Dim x As Integer

		sql = "UPDATE " & tableName & " SET "
		For x = 0 To UBound(dataNames)
			If x <> UBound(dataNames) Then
				sql = sql & dataNames(x) & "= '" & Replace(dataValues(x), "'", "''") & "', "
			Else
				sql = sql & dataNames(x) & "= '" & Replace(dataValues(x), "'", "''") & "' "
			End If
		Next
		sql = sql & condition

		ExecuteQuery(sql)

	End Sub

	'returns a recordset using CommandBehavior.CloseConnection
	Public Function sqlSelect(ByVal sQuery As String) As SqlDataReader

		Dim conn As SqlConnection
		Dim db As SqlCommand
		Dim rs As SqlDataReader

		conn = New SqlConnection(eConn)
		conn.Open()
		db = New SqlCommand(sQuery, conn)
		rs = db.ExecuteReader(CommandBehavior.CloseConnection)
		Return rs

	End Function

End Class
